diff --git a/backend/lispworks.lisp b/backend/lispworks.lisp
index 60a7f99..ac2ab27 100644
--- a/backend/lispworks.lisp
+++ b/backend/lispworks.lisp
@@ -65,7 +65,7 @@
     (if usock-err
         (if (subtypep usock-err 'error)
             (error usock-err :socket socket)
-          (signal usock-err :socket socket))
+          (signal usock-err)) ;; :socket socket)) ;; FJ
       (error 'unknown-error
              :socket socket
              :real-error condition
@@ -461,7 +461,7 @@
             (raise-usock-err errno socket-fd)))))))
     
 (defun receive-message (socket-fd message &optional buffer (length (length buffer))
-			&key read-timeout (max-buffer-size +max-datagram-packet-size+))
+			&key read-timeout (max-buffer-size +max-datagram-packet-size+) usocket)
   "Receive message from socket, read-timeout is a float number in seconds.
 
    This function will return 4 values:
@@ -489,7 +489,10 @@
           (declare (type fixnum n))
           ;; restore old read timeout
           (when (and read-timeout (/= old-timeout read-timeout))
-            (set-socket-receive-timeout socket-fd old-timeout))
+            (set-socket-receive-timeout socket-fd old-timeout))       
+          #+win32
+          (when usocket 
+            (setf (%ready-p usocket) nil))
           (if (plusp n)
               (values (if buffer
                           (replace buffer message
@@ -525,7 +528,8 @@
       (receive-message (socket socket)
                        (slot-value socket 'recv-buffer)
                        buffer length
-                       :read-timeout timeout)
+                       :read-timeout timeout
+                       :usocket socket)
     (values buffer size host port)))
 
 (defmethod get-local-name ((usocket usocket))
